> ## Documentation Index
> Fetch the complete documentation index at: https://docs.immutable.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Search NFTs

> Search NFTs



## OpenAPI

````yaml https://imx-openapiv3-mr-sandbox.s3.us-east-2.amazonaws.com/openapi.json get /v1/chains/{chain_name}/search/nfts
openapi: 3.0.3
info:
  title: Immutable zkEVM API
  version: 1.0.0
  description: Immutable Multi Rollup API
  contact:
    name: Immutable API Support
    email: support@immutable.com
    url: https://support.immutable.com
servers:
  - url: https://api.sandbox.immutable.com
security: []
tags:
  - name: activities
    description: Activities Endpoints
    x-displayName: activities
  - name: chains
    description: Chains Endpoints
    x-displayName: chains
  - name: collections
    description: Collections Endpoints
    x-displayName: collections
  - name: nfts
    description: NFTs Endpoints
    x-displayName: nfts
  - name: nft owners
    description: NFT Owner Endpoints
    x-displayName: nft owners
  - name: metadata
    description: NFT Metadata Endpoints
    x-displayName: metadata
  - name: tokens
    description: ERC20 Token Endpoints
    x-displayName: tokens
  - name: demopage
    description: Temporary HTML endpoint for demo purposes
    x-displayName: demopage
  - name: verification
    x-displayName: verification
  - name: operatorallowlist
    x-displayName: operatorallowlist
  - name: crafting
    x-displayName: crafting
  - name: listings
    description: Listings Endpoints
    x-displayName: listings
  - name: orders
    x-displayName: orders
  - name: passport
    description: Passport operations
    x-displayName: passport
  - name: gamefi
    description: team gamefi
    x-displayName: gamefi
  - name: health
    x-displayName: health
  - name: passport profile
    description: Passport Profile endpoints
    x-displayName: passport profile
  - name: feed-items
    x-displayName: feed-items
  - name: assets
    x-displayName: assets
  - name: guardian
    description: Guardian endpoints
    x-displayName: guardian
  - name: pricing
    description: Pricing Endpoints
    x-displayName: pricing
  - name: metadata-search
    x-displayName: metadata-search
paths:
  /v1/chains/{chain_name}/search/nfts:
    get:
      tags:
        - metadata-search
      summary: Search NFTs
      description: Search NFTs
      operationId: SearchNFTs
      parameters:
        - name: chain_name
          description: The name of chain
          in: path
          required: true
          schema:
            $ref: '#/components/schemas/ChainName'
          examples:
            testnet:
              value: imtbl-zkevm-testnet
              summary: Immutable zkEVM Public Testnet
        - name: contract_address
          in: query
          required: true
          description: List of contract addresses to filter by
          schema:
            type: array
            items:
              type: string
              pattern: ^0x[a-fA-F0-9]{40}$
              example: '0xe9b00a87700f660e46b6f5deaa1232836bcc07d3'
            maxItems: 20
            minItems: 1
        - name: account_address
          in: query
          required: false
          description: Account address to filter by
          schema:
            type: string
            pattern: ^0x[a-fA-F0-9]{40}$
            example: '0xe9b00a87700f660e46b6f5deaa1232836bcc07d3'
        - name: stack_id
          in: query
          required: false
          description: Filters NFTs that belong to any of these stacks
          schema:
            type: array
            items:
              type: string
              format: uuid
              example: 7053e765-c119-4efb-b5cf-405ccccaf6c4
            minItems: 1
            maxItems: 20
        - name: only_include_owner_listings
          in: query
          required: false
          description: Whether the listings should include only the owner created listings
          schema:
            type: boolean
            example: true
        - name: page_size
          in: query
          required: false
          description: Number of results to return per page
          schema:
            $ref: '#/components/schemas/PageSize'
        - name: page_cursor
          in: query
          description: >-
            Encoded page cursor to retrieve previous or next page. Use the value
            returned in the response.
          required: false
          schema:
            $ref: '#/components/schemas/PageCursor'
      responses:
        '200':
          description: 200 response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/SearchNFTsResult'
        '400':
          $ref: '#/components/responses/BadRequest'
        '401':
          $ref: '#/components/responses/UnauthorisedRequest'
        '403':
          $ref: '#/components/responses/ForbiddenRequest'
        '404':
          $ref: '#/components/responses/NotFound'
        '429':
          $ref: '#/components/responses/TooManyRequests'
        '500':
          $ref: '#/components/responses/InternalServerError'
components:
  schemas:
    ChainName:
      type: string
      description: The name of chain
      example: imtbl-zkevm-testnet
    PageSize:
      type: integer
      format: int32
      description: Maximum number of items to return
      minimum: 1
      default: 100
      maximum: 200
      example: 10
    PageCursor:
      type: string
      description: >-
        Encoded page cursor to retrieve previous or next page. Use the value
        returned in the response.
      example: >-
        ewogICJ0eXBlIjogInByZXYiLAogICJpdGVtIjogewogICAgImlkIjogNjI3NTEzMCwKICAgICJjcmVhdGVkX2F0IjogIjIwMjItMDktMTNUMTc6MDQ6MTIuMDI0MTI2WiIKICB9Cn0=
    SearchNFTsResult:
      type: object
      description: Search NFTs result
      properties:
        result:
          type: array
          description: List of nft bundles
          items:
            $ref: '#/components/schemas/NFTBundle'
        page:
          $ref: '#/components/schemas/Page'
      required:
        - result
        - page
    NFTBundle:
      type: object
      description: NFT bundle includes NFT with stack, markets and listings
      properties:
        nft_with_stack:
          $ref: '#/components/schemas/NFTWithStack'
        market:
          nullable: true
          allOf:
            - $ref: '#/components/schemas/Market'
        listings:
          type: array
          description: List of open listings for the NFT.
          maxItems: 10
          items:
            $ref: '#/components/schemas/Listing'
        bids:
          type: array
          description: List of open bids for the NFT.
          maxItems: 10
          items:
            $ref: '#/components/schemas/Bid'
      required:
        - nft_with_stack
        - market
        - listings
        - bids
    Page:
      type: object
      description: Pagination properties
      properties:
        previous_cursor:
          type: string
          nullable: true
          description: First item as an encoded string
          example: >-
            ewogICJ0eXBlIjogInByZXYiLAogICJpdGVtIjogewogICAgImlkIjogNjI3NTEzMCwKICAgICJjcmVhdGVkX2F0IjogIjIwMjItMDktMTNUMTc6MDQ6MTIuMDI0MTI2WiIKICB9Cn0=
        next_cursor:
          type: string
          nullable: true
          description: Last item as an encoded string
          example: >-
            ewogICJ0eXBlIjogInByZXYiLAogICJpdGVtIjogewogICAgImlkIjogNjI3NTEzMCwKICAgICJjcmVhdGVkX2F0IjogIjIwMjItMDktMTNUMTc6MDQ6MTIuMDI0MTI2WiIKICB9Cn0=
      required:
        - previous_cursor
        - next_cursor
    APIError400:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - VALIDATION_ERROR
              example: VALIDATION_ERROR
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    APIError401:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - UNAUTHORISED_REQUEST
              example: UNAUTHORISED_REQUEST
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    APIError403:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - AUTHENTICATION_ERROR
              example: AUTHENTICATION_ERROR
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    APIError404:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - RESOURCE_NOT_FOUND
              example: RESOURCE_NOT_FOUND
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    APIError429:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - TOO_MANY_REQUESTS_ERROR
              example: TOO_MANY_REQUESTS_ERROR
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    APIError500:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - INTERNAL_SERVER_ERROR
              example: INTERNAL_SERVER_ERROR
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    NFTWithStack:
      type: object
      description: Stack
      properties:
        token_id:
          description: Token id of NFT (uint256 as string)
          type: string
        stack_id:
          type: string
          format: uuid
          description: Stack ID
        chain:
          $ref: '#/components/schemas/Chain'
        contract_address:
          type: string
          description: Contract address
        contract_type:
          $ref: '#/components/schemas/MarketplaceContractType'
        created_at:
          type: string
          format: date-time
          example: '2022-08-16T17:43:26.991388Z'
          description: When the metadata was created
        updated_at:
          type: string
          format: date-time
          description: When the metadata was last updated
          example: '2022-08-16T17:43:26.991388Z'
        name:
          type: string
          nullable: true
          example: Sword
          description: The name of the NFT
        description:
          type: string
          nullable: true
          example: '2022-08-16T17:43:26.991388Z'
          description: The description of the NFT
        image:
          type: string
          nullable: true
          description: The image url of the NFT
          example: https://some-url
        external_url:
          type: string
          nullable: true
          description: The external website link of NFT
          example: https://some-url
        animation_url:
          type: string
          nullable: true
          description: The animation url of the NFT
          example: https://some-url
        youtube_url:
          type: string
          nullable: true
          description: The youtube URL of NFT
          example: https://some-url
        attributes:
          type: array
          description: List of Metadata attributes
          nullable: true
          items:
            $ref: '#/components/schemas/NFTMetadataAttribute'
        balance:
          type: integer
          description: Balance of NFT
          minimum: 1
          nullable: true
      required:
        - token_id
        - stack_id
        - chain
        - contract_address
        - contract_type
        - updated_at
        - created_at
        - name
        - description
        - image
        - external_url
        - animation_url
        - youtube_url
        - attributes
        - balance
    Market:
      type: object
      description: Market data
      properties:
        floor_listing:
          description: Cheapest active listing
          nullable: true
          allOf:
            - $ref: '#/components/schemas/Listing'
        top_bid:
          description: Highest active big
          nullable: true
          allOf:
            - $ref: '#/components/schemas/Bid'
        last_trade:
          $ref: '#/components/schemas/LastTrade'
      required:
        - top_bid
        - floor_listing
        - last_trade
    Listing:
      type: object
      properties:
        listing_id:
          type: string
          description: Global Order identifier
          example: 018792C9-4AD7-8EC4-4038-9E05C598534A
        price_details:
          $ref: '#/components/schemas/MarketPriceDetails'
        token_id:
          type: string
          description: Token ID
          example: '1'
        contract_address:
          type: string
          description: ETH Address of collection that the asset belongs to
          example: '0xe9b00a87700f660e46b6f5deaa1232836bcc07d3'
        creator:
          type: string
          description: ETH Address of listing creator
          example: '0xe9b00a87700f660e46b6f5deaa1232836bcc07d3'
        amount:
          type: string
          description: Amount of token included in the listing
          example: '1'
      required:
        - listing_id
        - price_details
        - creator
        - token_id
        - contract_address
        - amount
    Bid:
      type: object
      properties:
        bid_id:
          type: string
          description: Global Order identifier
          example: 018792C9-4AD7-8EC4-4038-9E05C598534A
        price_details:
          $ref: '#/components/schemas/MarketPriceDetails'
        token_id:
          type: string
          nullable: true
          description: >-
            Token ID. Null for collection bids that can be fulfilled by any
            asset in the collection
          example: '1'
        contract_address:
          type: string
          description: ETH Address of collection that the asset belongs to
          example: '0xe9b00a87700f660e46b6f5deaa1232836bcc07d3'
        creator:
          type: string
          description: ETH Address of listing creator
          example: '0xe9b00a87700f660e46b6f5deaa1232836bcc07d3'
        amount:
          type: string
          description: Amount of token included in the listing
          example: '1'
      required:
        - bid_id
        - price_details
        - creator
        - token_id
        - contract_address
        - amount
    BasicAPIError:
      type: object
      properties:
        message:
          type: string
          description: Error Message
          example: all fields must be provided
        link:
          type: string
          description: Link to IMX documentation that can help resolve this error
          example: https://docs.x.immutable.com/reference/#/
        trace_id:
          type: string
          description: Trace ID of the initial request
          example: e47634b79a5cd6894ddc9639ec4aad26
      required:
        - message
        - link
        - trace_id
    Chain:
      type: object
      description: The chain details
      properties:
        id:
          type: string
          description: The id of chain
          example: eip155:13372
        name:
          type: string
          description: The name of chain
          example: imtbl-zkevm-testnet
      required:
        - id
        - name
    MarketplaceContractType:
      description: The contract type for a collection
      type: string
      enum:
        - ERC721
        - ERC1155
    NFTMetadataAttribute:
      type: object
      properties:
        display_type:
          description: Display type for this attribute
          type: string
          nullable: true
          enum:
            - number
            - boost_percentage
            - boost_number
            - date
          example: number
        trait_type:
          description: The metadata trait type
          type: string
          example: Aqua Power
        value:
          oneOf:
            - type: string
            - type: number
            - type: boolean
          description: The metadata trait value
          example: Happy
      required:
        - trait_type
        - value
    LastTrade:
      type: object
      nullable: true
      description: Most recent trade
      properties:
        trade_id:
          type: string
          description: Trade ID
          format: uuid
          example: 4e28df8d-f65c-4c11-ba04-6a9dd47b179b
        contract_address:
          type: string
          description: ETH Address of collection that the asset belongs to
          example: '0xe9b00a87700f660e46b6f5deaa1232836bcc07d3'
        token_id:
          type: string
          description: Token id of the traded asset (uint256 as string)
          example: '1'
        price_details:
          type: array
          description: Price details, list of payments involved in this trade
          items:
            $ref: '#/components/schemas/MarketPriceDetails'
        amount:
          type: string
          description: Amount of the trade (uint256 as string)
          example: '1'
        created_at:
          type: string
          format: date-time
          description: When the trade was created
          example: '2022-08-16T17:43:26.991388Z'
      required:
        - trade_id
        - token_id
        - contract_address
        - price_details
        - amount
        - created_at
    MarketPriceDetails:
      type: object
      description: Market Price details
      properties:
        token:
          description: Token details
          oneOf:
            - $ref: '#/components/schemas/MarketPriceNativeToken'
            - $ref: '#/components/schemas/MarketPriceERC20Token'
          discriminator:
            propertyName: type
            mapping:
              NATIVE:
                $ref: '#/components/schemas/MarketPriceNativeToken'
              ERC20:
                $ref: '#/components/schemas/MarketPriceERC20Token'
        amount:
          $ref: '#/components/schemas/PaymentAmount'
        fee_inclusive_amount:
          $ref: '#/components/schemas/PaymentAmount'
        fees:
          type: array
          items:
            $ref: '#/components/schemas/MarketPriceFees'
          example:
            - type: TAKER_ECOSYSTEM
              recipient_address: '0xf39Fd6e51aad88F6F4ce6aB8827279cffFb92233'
              amount: '1000000000000000000'
        converted_prices:
          $ref: '#/components/schemas/ConvertedPrices'
      required:
        - token
        - amount
        - fee_inclusive_amount
        - fees
        - converted_prices
    MarketPriceNativeToken:
      type: object
      properties:
        type:
          type: string
          description: >-
            Token type user is offering, which in this case is the native IMX
            token
          example: NATIVE
          enum:
            - NATIVE
        symbol:
          nullable: true
          type: string
          description: The symbol of token
          example: IMX
      required:
        - type
        - symbol
    MarketPriceERC20Token:
      type: object
      properties:
        type:
          type: string
          description: Token type user is offering, which in this case is ERC20
          example: ERC20
          enum:
            - ERC20
        contract_address:
          type: string
          description: Address of ERC20 token
          example: '0x0165878A594ca255338adfa4d48449f69242Eb8F'
          pattern: ^0x[a-fA-F0-9]{40}$
        symbol:
          nullable: true
          type: string
          description: The symbol of token
          example: ETH
        decimals:
          type: integer
          description: The decimals of token
          example: 18
          nullable: true
      required:
        - type
        - contract_address
        - symbol
        - decimals
    PaymentAmount:
      type: string
      description: >-
        The token amount value. This value is provided in the smallest unit of
        the token (e.g. wei for ETH)
      example: '9750000000000000000'
      pattern: \d+
    MarketPriceFees:
      type: object
      properties:
        amount:
          type: string
          description: Fee in the payment currency
          example: '1000000000000000000'
        type:
          type: string
          description: Fee type
          example: ROYALTY
          enum:
            - ROYALTY
            - MAKER_ECOSYSTEM
            - TAKER_ECOSYSTEM
            - PROTOCOL
        recipient_address:
          type: string
          description: Wallet address of fee recipient
          example: '0xf39Fd6e51aad88F6F4ce6aB8827279cffFb92233'
          pattern: ^0x[a-fA-F0-9]{40}$
      example:
        amount: '1000000000000000000'
        type: ROYALTY
        recipient_address: '0xf39Fd6e51aad88F6F4ce6aB8827279cffFb92233'
      required:
        - type
        - amount
        - recipient_address
    ConvertedPrices:
      type: object
      description: >-
        A mapping of converted prices for major currencies such as ETH, USD. All
        converted prices are fee-inclusive.
      nullable: true
      additionalProperties:
        type: string
      example:
        ETH: '0.0058079775'
        USD: '15.89'
  responses:
    BadRequest:
      description: Bad Request (400)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError400'
    UnauthorisedRequest:
      description: Unauthorised Request (401)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError401'
    ForbiddenRequest:
      description: Forbidden Request (403)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError403'
    NotFound:
      description: The specified resource was not found (404)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError404'
    TooManyRequests:
      description: Too Many Requests (429)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError429'
      headers:
        Retry-After:
          $ref: '#/components/headers/RetryAfter'
    InternalServerError:
      description: Internal Server Error (500)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError500'
  headers:
    RetryAfter:
      description: The number of seconds until the next request can be made.
      schema:
        type: string

````